package com.iformall.controller.market;

import com.github.pagehelper.PageInfo;
import com.iformall.annotation.SystemControllerLog;
import com.iformall.common.ErrorCode;
import com.iformall.common.Result;
import com.iformall.common.ResultData;
import com.iformall.controller.base.BaseController;
import com.iformall.domain.po.base.BaseEntity;
import com.iformall.domain.po.WxFloatingLayer;
import com.iformall.domain.vo.WxFloatingLayerVO;
import com.iformall.enums.EnumFloatingLayerStatus;
import com.iformall.exception.MallinkException;
import com.iformall.service.WxFloatingLayerService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * @author gongbiao
 */
@RestController
@RequestMapping("wxFloatingLayer")
@Api(description = "首页浮层展示")
public class WxFloatingLayerController extends BaseController {
    private final Logger logger = LoggerFactory.getLogger(this.getClass());

    @Autowired
    WxFloatingLayerService wxFloatingLayerService;

    @ApiOperation("分页列表接口")
    @GetMapping("/list")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "页数", dataType = "int", paramType = "query", required = true),
            @ApiImplicitParam(name = "pageSize", value = "每页条数", dataType = "int", paramType = "query", required = true)})
    @SystemControllerLog(description = "列表")
    public ResultData list(@ModelAttribute WxFloatingLayer wxFloatingLayer, Integer pageNum, Integer pageSize) {
        logger.debug("[" + getIpAddr() + "] WxFloatingLayerController::list");
        wxFloatingLayer.setTenantId(getTenantId());
        wxFloatingLayer.setSortColumns(BaseEntity.SortField.CreateTime_DESC, BaseEntity.SortField.Id_DESC);
        final PageInfo<WxFloatingLayerVO> page = wxFloatingLayerService.listAsPage(wxFloatingLayer, pageNum, pageSize);
        return new ResultData(page);
    }

    @ApiOperation("新增接口")
    @PostMapping("/add")
    @SystemControllerLog(description = "新增")
    public ResultData add(@RequestBody WxFloatingLayer wxFloatingLayer) {
        logger.debug("[" + getIpAddr() + "] WxFloatingLayerController::add");
        wxFloatingLayer.setStatus(EnumFloatingLayerStatus.STATUS_THROW_IN.getCode());
        wxFloatingLayer.setTenantId(getTenantId());
        try {
            return wxFloatingLayerService.saveOrUpdate(wxFloatingLayer);
        } catch (MallinkException e) {
            logger.error(e.getMessage());
            return new ResultData(e.getErrorCode(), e.getMessage());
        }
    }

    @ApiOperation("根据id更新接口")
    @PostMapping("/updateStatus")
    @SystemControllerLog(description = "id更新")
    public ResultData updateStatus(@RequestBody WxFloatingLayer wxFloatingLayer) {
        logger.debug("[" + getIpAddr() + "] WxFloatingLayerController::updateStatus");
        if (wxFloatingLayer.getId() == null) {
            return new ResultData(ErrorCode.SYS_PARAMETER_NOT_NULL.getCode(), "id不能为空");
        }
        try {
            wxFloatingLayer.setStatus(EnumFloatingLayerStatus.STATUS_TAKE_OFFF.getCode());
            return wxFloatingLayerService.updateStatus(wxFloatingLayer);
        } catch (MallinkException e) {
            logger.error(e.getMessage());
            return new ResultData(e.getErrorCode(), e.getMessage());
        }
    }

    @ApiOperation("根据id查询接口")
    @GetMapping("/findById")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    @SystemControllerLog(description = "活动-查询")
    public ResultData findById(Long id) {
        logger.debug("[" + getIpAddr() + "] WxFloatingLayerController::findById");
        WxFloatingLayer wxFloatingLayer = wxFloatingLayerService.getById(id);
        return new ResultData(Result.SUCCESS, "查询成功", wxFloatingLayer);
    }

}
